#! /bin/bash
# Jetpack Xephyr Launch Script
# By Hamish Paul Wilson on 2025/03/16

# This script expects the following packages to be installed to launch on Arch Linux:
# xorg-server-xephyr xorg-xsetroot xcursor-themes xorg-fonts-misc sox

# To disable the DEMO level at the start rename jetpack.lev001 to jetpack.lev000
# The original manual page can be installed by moving jetpack.man to be /usr/local/man/man6/jetpack.6

# Music WAV files extracted from the Macintosh shareware version of Jetpack also by Mark Bradley.
# See INFORMATION for further details.

# Reverts to X defaults on exit
trap "{
xsetroot -cursor_name left_ptr
pkill Xephyr
}" SIGINT EXIT

# Defines media player (default is SoX)
mediaPlayer=play

# Changes to the directory of the script
cd "$(dirname "$0")"

# Launches Jetpack in a dedicated Xephyr window
chmod --quiet u+w jetpack.scores
Xephyr -softCursor -screen 502x552x8 :1 &
sleep 0.5
DISPLAY=:1 ./jetpack &

# Changes mouse cursor
xsetroot -cursor_name shuttle

# Plays intro music
$mediaPlayer music/0.wav

# Randomly loops level music
while :
do
# Checks to see if Jetpack is running
 running=$(pgrep -x jetpack)
 if [ -z "$running" ]; then
  break
 fi

# Sets a randum number between 0 and 3
 ranNum=$((0 + $RANDOM % 3))

# Uses random number to determine a track
 if [ $ranNum -eq 0 ] ; then
  $mediaPlayer music/1.wav
 elif [ $ranNum -eq 1 ] ; then
  $mediaPlayer music/2.wav
 elif [ $ranNum -eq 2 ] ; then
  $mediaPlayer music/3.wav
 elif [ $ranNum -eq 3 ] ; then
  $mediaPlayer music/4.wav
 fi
done
